﻿//--------------------------------------------------------------------- 
//THIS CODE AND INFORMATION ARE PROVIDED AS IS WITHOUT WARRANTY OF ANY 
//KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE 
//IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A 
//PARTICULAR PURPOSE. 
//---------------------------------------------------------------------
using System;
using System.Linq;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Msdn.UIFramework;

namespace Msdn.TestClient
{
    public partial class DemoForm : UIForm
    {
        private bool garden = true;

        public DemoForm()
        {
            InitializeComponent();
            // Set gradient for title bar
            this.TitleBar.Fill = new LinearGradient(Color.DarkBlue, Color.CornflowerBlue);
            this.TitleBar.Text = this.Text;
            // Set values for menu
            this.MenuBar.LeftMenu = "Exit";
            this.MenuBar.RightMenu = "Location";

            this.InitializeWeatherUI("75", "Redmond, WA", 50, 50);
            this.InitializeSlideShow(50, 140, "Garden.jpg");
            //this.InitList();
        }

        //private void InitList()
        //{
        //    ListElement listControl = new ListElement();
        //    listControl.Left = 10;
        //    listControl.Top = 30;
        //    listControl.Width = 200;
        //    listControl.Height = 200;
        //    listControl.Border.CornerRadius = 5;
        //    listControl.Border.Fill = new LinearGradient(Color.CornflowerBlue, Color.LightBlue);
        //    listControl.Border.Foreground = Color.CornflowerBlue;

        //    for (int c = 0; c < 10; c++)
        //    {
        //        ListItem item = new ListItem();
        //        item.Width = listControl.Width;
        //        item.Height = 30;
        //        item.AddElement<Border>(() => new Border()
        //        {
        //            Background = Color.Gold,
        //            Opacity = 200,
        //            Left = listControl.Left,
        //            Height = item.Height,
        //            Width = listControl.Width
        //        });

        //        item.AddElement<TextBlock>(() => new TextBlock()
        //        {
        //            Text = "Alex Yakhnin",
        //            Left = listControl.Left,
        //            Height = item.Height,
        //            Width = listControl.Width
        //        });

        //        listControl.Items.Add(item);
        //    }

        //    this.Canvas.Children.Add(listControl);

        //}

        private void InitializeSlideShow(int left, int top, string imageFile)
        {
            this.Canvas.AddElement<ImageElement>(() => new ImageElement()
            {
                Source = @"Images\slideshow_glass_frame.png",
                Top = top,
                Left = left,
                AlphaChannel = true,
            });

            this.Canvas.AddElement<ImageElement>(() => new ImageElement()
            {
                Name = "Slide",
                Source = @"Images\" + imageFile,
                Top = top + 5,
                Left = left + 4,
                Stretch = true,
                Width = 120,
                Height = 90
            });
        }


        private void InitializeWeatherUI(string temperature, string city, int left, int top)
        {           

            this.Canvas.AddElement<ImageElement>(() => new ImageElement()
            {
                Source = @"Images\BLUEDOCKED-base.png",               
                Top = top,
                Left = left,      
                AlphaChannel = true,
            });

            this.Canvas.AddElement<ImageElement>(() => new ImageElement()
            {
                Source = @"Images\docked_sun.png",                
                Top = top,
                Left = left,
                AlphaChannel = true,
            });

            this.Canvas.AddElement<ImageElement>(() => new ImageElement()
            {
                Source = @"Images\docked_cloudy.png",                
                Top = top,
                Left = left,
                AlphaChannel = true,
            });

            this.Canvas.AddElement<ImageElement>(() => new ImageElement()
            {
                Source = @"Images\BLUEDOCKED-highlight-02.png",               
                Top = top + 2,
                Left = left + 3,
                AlphaChannel = true,
            });

            // Display temperature
            this.Canvas.AddElement<TextBlock>(() => new TextBlock()
            {
                Text = temperature + Convert.ToChar(176),
                Top = top + 2,
                Left = left + 97,              
                FontSize = 12f,
                FontStyle = FontStyle.Bold
            });

            // Display city
            this.Canvas.AddElement<TextBlock>(() => new TextBlock()
            {
                Text = city,
                Top = top + 40,
                Left = left + 40,
                Width = 200,                
            });           
        }

        private void timer_Tick(object sender, EventArgs e)
        {
            if (garden)
            {
                ((ImageElement)this.Canvas.Children["Slide"]).Source = "Images\\Dock.jpg";
                garden = false;
            }
            else
            {
                ((ImageElement)this.Canvas.Children["Slide"]).Source = "Images\\Garden.jpg";
                garden = true;
            }
        }
    }
}