﻿using System;
using System.ComponentModel;
using System.Collections.Generic;
using System.Diagnostics;
using System.Text;
using System.Windows.Forms;

namespace NumericTextBox
{
    public class NumericTextBox : TextBox
    {
        public delegate void NumberEnteredEventHandler(object sender,EventArgs e);
        public event NumberEnteredEventHandler NumberEntered;

        public delegate void IllegalCharacterEnteredEventHandler(object sender,EventArgs e);
        public event IllegalCharacterEnteredEventHandler IllegalCharacterEntered;

        protected override void OnKeyPress(KeyPressEventArgs e)
        {
            base.OnKeyPress(e);

            if (char.IsDigit(e.KeyChar))
            {
                //Digits are allowed,we don't need to take any further action
                if (NumberEntered != null)
                {
                    NumberEntered(this, EventArgs.Empty);
                }
            }
            else if (e.KeyChar == '\b')
            {
                //Backspaces are allowed,we don't need to take any further action
                if (NumberEntered != null)
                {
                    NumberEntered(this, EventArgs.Empty);
                }
            }
            else 
            {
                //For this demo each other key is illegal,we just eat up the key but don't need to take any further action
                e.Handled = true;

                if (IllegalCharacterEntered != null)
                {
                    IllegalCharacterEntered(this, EventArgs.Empty);
                }
            }
        }
    }
}
